-- Test edit_amenity_feature
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to camper, public;

select has_function('camper', 'edit_amenity_feature', array['integer', 'text', 'text']);
select function_lang_is('camper', 'edit_amenity_feature', array['integer', 'text', 'text'], 'sql');
select function_returns('camper', 'edit_amenity_feature', array['integer', 'text', 'text'], 'integer');
select isnt_definer('camper', 'edit_amenity_feature', array['integer', 'text', 'text']);
select volatility_is('camper', 'edit_amenity_feature', array['integer', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'edit_amenity_feature', array ['integer', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'edit_amenity_feature', array ['integer', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'edit_amenity_feature', array ['integer', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'edit_amenity_feature', array ['integer', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate amenity_feature cascade;
truncate amenity cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into amenity (amenity_id, company_id, label, name)
values (4, 1, 'A1', 'Amenity A1')
;

insert into amenity_feature (amenity_feature_id, amenity_id, icon_name, name)
values (5, 4, 'information', 'Feature 1')
     , (6, 4, 'wifi', 'Feature 2')
;

select lives_ok(
	$$ select edit_amenity_feature(5, 'toilet', 'Feature A') $$,
	'Should be able to edit the first feature'
);

select lives_ok(
	$$ select edit_amenity_feature(6, 'baby', 'Feature B') $$,
	'Should be able to edit the second feature'
);

select bag_eq(
	$$ select amenity_feature_id, amenity_id, icon_name, name from amenity_feature $$,
	$$ values (5, 4, 'toilet', 'Feature A')
	        , (6, 4, 'baby', 'Feature B')
	$$,
	'Should have updated all amenity type features.'
);


select *
from finish();

rollback;
